local filtersites = { }
filtersites["www.bloomberg.com"] = true
filtersites["www.nytimes.com"] = true
filtersites["www.washingtonpost.com"] = true
filtersites["www.wsj.com"] = true


local invissel = cssfilter(".visually-hidden")
local newslettersel = cssfilter(".newsletter-signup")
local titlesel = cssfilter("title")
local headersel = cssfilter("header.post__header")
local ziprsel = cssfilter("div.zipr-recirc")

local articlesels = {
	cssfilter("article"),
	cssfilter("#content"),
	cssfilter("div#article"),
	cssfilter("div.article"),
	cssfilter("div#main"),
	cssfilter("div.post-outer"),
	cssfilter(".l-root"),
	cssfilter(".content-container"),
}
local commentssel = cssfilter("div#comments")

function shouldfilter(host)
	if host:match("github.com") then return "" end
	if host:match("amazon.com") then return "" end
	return "yeah"
end

function prefilter(req)
	local host = reqgethost(req)
	host = host:gsub("www.reddit.com", "old.reddit.com")
	reqsethost(req, host)
end

function filter(outw, req, host, path, root, bodybytes)
	print("trying to filter in lua", host, path)
	if path == "/" then
		return ""
	end
	local article
	for i = 1, #articlesels do
		article = matchall(root, articlesels[i])
		if #article > 0 then
			break
		end
	end
	if #article ~= 1 then
		return ""
	end
	article = article[1]

	writestring(outw, prolog)
	local title = matchfirst(root, titlesel)
	if title then
		clean(outw, title, req)
	end
	local header = matchfirst(root, headersel)
	if header then
		clean(outw, header, req)
	end
	if host == "www.washingtonpost.com" then
		local headlinesel = cssfilter("#topper-headline-wrapper")
		local headline = matchfirst(root, headlinesel)
		if headline then
			clean(outw, headline, req)
		end
	end
	if host == "www.nytimes.com" then
		local hidden = matchall(article, invissel)
		for i = 1, #hidden do
			removenode(hidden[i])
		end
		hidden = matchall(article, newslettersel)
		for i = 1, #hidden do
			removenode(hidden[i])
		end
	end
	local ziprdiv = matchfirst(article, ziprsel)
	if ziprdiv then
		print("removed the zipr")
		removenode(ziprdiv)
	end
	local commentsdiv = matchfirst(article, commentssel)
	if commentsdiv then
		removenode(commentsdiv)
	end

	clean(outw, article, req)
	print("i did it, i cleaned it")
	return "cleaned"
end

prolog = [==[
<!doctype html><html><meta charset="utf-8">
<style>
body {
	max-width: 940px;
	margin: auto;
	font-size: 1.4em;
	line-height: 1.5;
}
img {
	max-width: 900px;
}
pre {
	white-space: pre-wrap;
	word-wrap: break-word;
}
</style>
<body>
]==]
